public class FibGenerator implements Runnable {
 
  public static void main(String[] args)
      throws InterruptedException {
    FibGenerator task = new FibGenerator();
    Thread thread = new Thread(task);
    thread.start();
    try {
      TimeUnit.SECONDS.sleep(1);
    } finally {
      System.out.println("cancel start");
      task.cancel();
      thread.join();
      System.out.println("cancel finish");
    }
  }
 
  private volatile boolean cancelled = false;
 
  private final List<BigInteger> fibonaccis =
      new ArrayList<BigInteger>();
 
  // tB{ib`vZ郁\bh
  private BigInteger fibonacci(BigInteger n) {
    if (n.equals(BigInteger.ZERO) || n.equals(BigInteger.ONE)) {
      return n;
    }
    BigInteger a = n.add(BigInteger.valueOf(-2));
    BigInteger b = n.add(BigInteger.valueOf(-1));
    return fibonacci(a).add(fibonacci(b));
  }
 
  @Override
  public void run() {
    BigInteger n = BigInteger.ONE;
    while (cancelled == false) {
      BigInteger f = fibonacci(n);
      System.out.printf("fib(%s) = %s\n", n, f);
      fibonaccis.add(f);
      n = n.add(BigInteger.ONE);
    }
  }
 
  public void cancel() {
    cancelled = true;
  }
 
  public List<BigInteger> getFibonaccis() {
    return fibonaccis;
  }
}